// Hello World (network).cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "Hello World (network).h"
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//Include novaPDF headers
#include "..\..\..\include\novaOptions.h"
#include <winspool.h>

#include "PrinterNameDlg.h"

#ifdef SetDefaultPrinter
#undef SetDefaultPrinter
#endif

//NovaPdfOptions
#include "..\..\..\include\novapi.h"
//name of novaPDF Printer Demo
#define PRINTER_NAME    L"novaPDF SDK 9"

//text to be written in the PDF file
#define PDF_TEXT        L"Hello Network World!"

//PDF file name
#define PDF_FILE_NAME   L"HelloWorldNet.pdf"

//Profile name
#define PROFILE_NAME       L"HelloWorldNet Profile"
#define PROFILE_IS_PUBLIC  0

//Register novaPDF COM from novapi7.dll
HRESULT RegisterNovaCOM(BOOL bRegister = TRUE)
{
	HRESULT hr = E_FAIL;
	WCHAR szFileName[_MAX_PATH] = L"";

	//find out application path and name
	DWORD dwRes = GetModuleFileNameW(NULL, szFileName, _MAX_PATH);

	if (dwRes > 0 && dwRes < _MAX_PATH) 
	{
		WCHAR szDir[_MAX_PATH], szDrive[_MAX_DRIVE];

		//get application path
		_wsplitpath(szFileName, szDrive, szDir, NULL, NULL);
		wcscpy(szFileName, szDrive);
		wcscat(szFileName, szDir);
	}

	//add COM dll name
	wcscat(szFileName, L"novapi90.dll");

	//load COM dll
	HMODULE hNova = LoadLibraryW(szFileName);

	typedef HRESULT (STDAPICALLTYPE *DllRegisterServerFunction)(void);
	DllRegisterServerFunction fun = NULL;

	if (hNova)
	{
		if (bRegister)
		{
			//get the address of DllRegisterServer function
			fun = (DllRegisterServerFunction) GetProcAddress(hNova, "DllRegisterServer");
		}
		else
		{
			//get the address of DllUnregisterServer function
			fun = (DllRegisterServerFunction) GetProcAddress(hNova, "DllUnregisterServer");
		}
		if (fun)
		{
			// call DllRegisterServer (or DllUnregisterServer)
			hr = fun();
		}
	}
	return hr;
}

HRESULT PrintSample(void)
{
	HRESULT hr = S_OK;

	//initialize COM
	hr = CoInitialize(NULL);

	// register the NovaPdfOptions COM module found in the executable's directory
	// The application must run with administrative rights to be able to regiter the COM
	// If you cannot run with administrative right, use the Registration-free COM technology instead
	//hr = RegisterNovaCOM(TRUE);

	//create one NovaPdfOptions instance
	INovaPdfOptions90 *pNova = 0;
	hr = CoCreateInstance(__uuidof(NovaPdfOptions90), NULL, CLSCTX_INPROC_SERVER, __uuidof(INovaPdfOptions90), (LPVOID*) &pNova);

	if (SUCCEEDED(hr)) 
	{

		DWORD dwSize = 256;
		WCHAR strWorkStation[256];

		//find out computer name
		GetComputerNameW(strWorkStation, &dwSize);

		PrinterNameDlg dlg;
		//construct printer name as "\\computer name\printer name"
		dlg.m_strPrinterName.Format(L"\\\\%s\\%s", strWorkStation, PRINTER_NAME);

		//get printer name from user
		if (IDCANCEL == dlg.DoModal())
		{
			return hr;
		}
		CString strPrinterName = dlg.m_strPrinterName;

		// initialize the NovaPdfOptions object to use with a printer licensed for SDK
		hr = pNova->Initialize(const_cast<WCHAR*>((LPCWSTR)strPrinterName), L"");

		if (SUCCEEDED(hr)) 
		{
			LPWSTR pwsOldActiveProfileID = NULL;
			LPWSTR pwsNewProfileID = NULL;

			hr = pNova->GetActiveProfile(&pwsOldActiveProfileID);

			//create a new profile with default settings
			hr = pNova->AddProfile(PROFILE_NAME, PROFILE_IS_PUBLIC, &pwsNewProfileID);

			//load the newly created profile
			if (SUCCEEDED(hr) && pwsNewProfileID) 
			{
				hr = pNova->LoadProfile(pwsNewProfileID);
			}
			else
			{
				MessageBox(NULL, L"Failed to create profile", L"novaPDF", MB_OK); 
				return hr;
			}

			// set PDF document Title
			hr = pNova->SetOptionString(NOVAPDF_DOCINFO_TITLE, L"Hello World Network Sample");

			//save profile changes
			hr = pNova->SaveProfile();
			//set as active profile for printer
			pNova->SetActiveProfile(pwsNewProfileID);

			HANDLE     hPrinter;
			PDEVMODEW  pDevmode = NULL;
			PRINTER_DEFAULTSW pd = { NULL, NULL, PRINTER_ACCESS_USE };

			//start a print job
			if (OpenPrinterW(const_cast<WCHAR*>((LPCWSTR)strPrinterName), &hPrinter, &pd)) {

				//get default printer DEVMODE
				int nSize = DocumentPropertiesW(NULL, hPrinter, const_cast<WCHAR*>((LPCWSTR)strPrinterName), NULL, NULL, 0);
				pDevmode = (PDEVMODEW)LocalAlloc(LPTR, nSize);
				DocumentPropertiesW(NULL, hPrinter, const_cast<WCHAR*>((LPCWSTR)strPrinterName), pDevmode, NULL, DM_OUT_BUFFER);

				//set page size in DEVMODE
				pDevmode->dmPaperSize = DMPAPER_USER;
				pDevmode->dmPaperLength = 2970;//5940;
				pDevmode->dmPaperWidth = 2100;//4200;
				pDevmode->dmFields = DM_PAPERSIZE | DM_PAPERLENGTH | DM_PAPERWIDTH;
				DocumentProperties(NULL, hPrinter, PRINTER_NAME, pDevmode, pDevmode, DM_IN_BUFFER | DM_OUT_BUFFER);

				//Print a page
				HDC hDC = CreateDCW(L"", strPrinterName, NULL, pDevmode);
				DOCINFOW docInfo = {sizeof(DOCINFO)};
				docInfo.lpszDocName = PDF_FILE_NAME; // PDF document name and path
				StartDocW(hDC,&docInfo);
				StartPage(hDC);
				TextOutW(hDC, 100, 80, PDF_TEXT, (int) wcslen(PDF_TEXT)); // Draw text on page
				EndPage(hDC);
				EndDoc(hDC);
				DeleteDC(hDC);

				//print job sent to printer
				MessageBoxW(NULL, L"Print job sent to printer", L"novaPDF", MB_OK); 

				LocalFree(pDevmode);
				ClosePrinter(hPrinter);
			}
			else 
			{
				WCHAR wsMessage[255];
				swprintf(wsMessage, L"OpenPrinter failed, error = %d", GetLastError());
				MessageBoxW(NULL, wsMessage, L"novaPDF", MB_OK); 
			}
			//restore default profile
			pNova->SetActiveProfile(pwsOldActiveProfileID);

			//delete newly created profile
			pNova->DeleteProfile(pwsNewProfileID);
			//free memory
			CoTaskMemFree(pwsNewProfileID);
			CoTaskMemFree(pwsOldActiveProfileID);
		}
		else 
		{
			MessageBoxW(NULL, L"Failed to initialize novaPDF Printer", L"novaPDF", MB_OK); 
		}

		//release NovaPdfOptions
		pNova->Release();

	}
	else
	{
		MessageBoxW(NULL, L"Failed to initialize COM", L"novaPDF", MB_OK); 
	}

	CoUninitialize();
	return 0;
}


// The one and only application object
CWinApp theApp;

using namespace std;

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		_tprintf(_T("Fatal Error: MFC initialization failed\n"));
		nRetCode = 1;
	}
	else
	{
		PrintSample();
	}
	return nRetCode;
}
